<!DOCTYPE html>
<html>

<head>
  <title> Task 32.50 - Load All users</title>
  <meta charset="UTF-8">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container p-4 text-center">
    <h3><b>Danh Sách người dùng đăng ký</b></h3>
    <div class="text-left form-group">
      <button class="btn btn-success" id="btn-new-user">New User</button>
    </div>
    <!-- TODO 1: Thêm 1 dòng mới thủ công ở table trên (thêm thủ công  bằng HTML) -->
    <table id="table-users" class="table table-bordered table-striped">
      <thead>
        <!-- phần head, dòng tiêu đề  của bảng -->
        <tr>
          <td>Id </td>
          <td> First Name </td>
          <td> Last Name </td>
          <td> Country</td>
          <td> Subject </td>
          <td> Customer Type</td>
          <td> Register Status</td>
          <td> Action</td>
        </tr>
      </thead>
      <tbody>
        <!-- phần dữ liệu của bảng -->

      </tbody>
    </table>

<script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
 
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  });
  // $("#table-users").on("click",".btn-edit" , function(){
  //     onBtnEditClick(this);
  //   });
    // $(".btn-edit").on("click", function(){
    //   onBtnEditClick(this);
    // });
    $("#table-users").on("click",".btn-delete" , function(){
      onBtnDeleteClick(this);       //có thể gắn sau sự kiện LoadDataTo Table, xem nút Edit
    });
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading(){
    console.log("Tải trang...");
    callApiGetDataUser();
  }
  function onBtnEditClick(paramBtnEdit){
    console.log("Nut Edit đc bấm...");
    console.log("User Id: " +$(paramBtnEdit).data("id"));
    console.log("User Register Status: "+$(paramBtnEdit).data("registerStatus"));

    const vDETAIL_FORM_URL = "UserDetails.html";
    var vUrlSiteToOpen=    vDETAIL_FORM_URL+"?"+ "id="+$(paramBtnEdit).data("id");
    window.location.href=vUrlSiteToOpen;
  }
  function onBtnDeleteClick(paramBtnDelete){
    console.log("Nut Delete đc bấm...");
    console.log("First Name: " +$(paramBtnDelete).data("firstname"));
    console.log("Last Name: "+$(paramBtnDelete).data("lastname"));
  }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function callApiGetDataUser(){
    "use strict";
    $.ajax({
      url: "http://203.171.20.210:8080/devcamp-register-java-api/users/",
      type: "GET",
      dataType: "json",
      success: function(res) {
        console.log(res);
        loadDataUserToTable(res);
        $(".btn-edit").on("click", function(){
           onBtnEditClick(this);
        });
        $("#btn-new-user").on("click", function(){
          onBtnNewUserClick();
        });
      },
      error: function(ajaxContext) {
        console.log(ajaxContext.responseText);
      },
    });
  }
  function loadDataUserToTable(paramUsersRes){
    for (var bI=0; bI<paramUsersRes.length; bI++){
    var bNewRow=$("<tr>").appendTo("#table-users");
      $("<td>").html(paramUsersRes[bI].id).appendTo(bNewRow);
      $("<td>").html(paramUsersRes[bI].firstname).appendTo(bNewRow);
      $("<td>").html(paramUsersRes[bI].lastname).appendTo(bNewRow);
      $("<td>").html(paramUsersRes[bI].country).appendTo(bNewRow);
      $("<td>").html(paramUsersRes[bI].subject).appendTo(bNewRow);
      $("<td>").html(paramUsersRes[bI].customerType).appendTo(bNewRow);
      $("<td>").html(paramUsersRes[bI].registerStatus).appendTo(bNewRow);
        //tạo cell vào row, gắn 2 nút vào cell, gắn thuộc tính  và hàm vào từng nút
        var bCellAction=$("<td>").appendTo(bNewRow);
        var bButtonEdit=$("<button>Sửa</button>")
          .addClass("btn btn-info  btn-edit")
          .data("id", paramUsersRes[bI].id)
          .data("firstname",paramUsersRes[bI].firstname)
          .data("lastname", paramUsersRes[bI].lastname)
          .data("country", paramUsersRes[bI].country)
          .data("subject", paramUsersRes[bI].subject)
          .data("customerType", paramUsersRes[bI].customerType)
          .data("registerStatus", paramUsersRes[bI].registerStatus)
          .appendTo(bCellAction);
        var vButtonDelete=$("<button>Xóa</button>")
          .addClass("btn btn-danger  btn-delete")
          .data("id", paramUsersRes[bI].id)
          .data("firstname",paramUsersRes[bI].firstname)
          .data("lastname", paramUsersRes[bI].lastname)
          .data("country", paramUsersRes[bI].country)
          .data("subject", paramUsersRes[bI].subject)
          .data("customerType", paramUsersRes[bI].customerType)
          .data("registerStatus", paramUsersRes[bI].registerStatus)
          .appendTo(bCellAction);
      }
  }
  function  onBtnNewUserClick(){
    window.location.href="AddNewUser.html";
  }
</script>

</body>

</html>